
$fn = 200;

PI =3.1415927;

// Nuts and bolts dimensions
M3_hole = 3.2;
M3_nut_e = 6.4;

// Ball bearing dimensions
bb_do = 30+0.2;
bb_h = 9 + 2;
bb_di = 10;

// Aluminum bar dimensions for chassis frame
bar_e = 20;
bar_wall = 1;

// Standard servo dimensions
servo_w = 20;
servo_l = 40;
servo_lt = 53;
servo_h1 = 26.67;
servo_h2 = 9.35;
servo_h = servo_h1 + servo_h2;
servo_m_d = 10.15;
servo_m_l = (servo_lt-servo_l)/2;

servo_cut_w = 41;
servo_cut_h = 21;
servo_mount_x = 50/2;
servo_mount_d = 10;
servo_mount_d2 = 48.76;
servo_axis_offset = 9.66;

// Board dimensions
board_l = 130;
board_w = 55;
board_h = 30;

wheel_d = 165;
wheel_w = 48;
tire_d = wheel_w * 1.3;


// Track dimensions
track_l = 57.5;
track_h = 26;
track_wall = 3.5;
track_w = wheel_w + 3 * track_wall;
link_w = 20;
track_tolerance_w = 0.6;
tow = 8; //Tracks On Wheel

ch_dis_x = 10;
ch_dis_y = 10;

Assembled = 0;

if(Assembled == 0){
//  camera_mount();
//  servo_mount();
//  board_mount();
//  pi_mount();
//  arduino_mount();
//  LED_board_mount();
//  sensor_disc_motor();
//  sensor_spacer();
  sensor_disc_gear();
//  motor_mount();
}
else{
  
  //12V 44aH Lead acid battery
  translate([0, 0, 100]){
    cube(size=[210, 180, 180], center=true);
  }
  
  
  for(i=[0:1:1]){
    mirror([0,i,0]){
      translate([0, -60, 45]){
  //      board_mount(1);
      }
    }
  }

  if(Assembled){
    translate([0, 0, 50]){
      chassis();
    }

    translate([175, 0, 38]){
      rotate([0, 0, -90]){
        camera_mount();
      }
    }

  }
}

module sensor_spacer(){
  ss_l = 12;
  ss_w = 6;
  ss_h = 6;
  
  translate([0, 0, ss_h/2])
  cube(size=[ss_l, ss_w, ss_h], center=true);
  
}

module motor_mount(){
  motor_d =25.5;
  mm_l = 170;
  mm_w = 40;
  mm_wall = 2;
  motor_X = 35;
  motor_m_h = 13;
  gear_X = -20;
  gear_m_h = 17;
  cut_X = 5;
  cut_w = 10;
  cut_m_l = 30;
  cut_m_h = 10;
  screw_e = 5;
  
  // Sensor parameters
  s1_X = motor_X + 35 + 4;
  s1_h = 16 - 4;
  s1_w = 15;
  s_wall = 5;

  s2_X = gear_X - 49 - 4;  
  s2_h = 22 - 4;

//  translate([motor_X, 0, 16]){
//    sensor_disc_motor();
//  }

//  translate([gear_X, 0, 20]){
//    sensor_disc_gear();
//  }

  
  difference(){
    union(){
      roundedRect([mm_l, mm_w, mm_wall], 5);
      translate([motor_X, 0, motor_m_h/2]){
        cylinder(d=motor_d+2*mm_wall, h=motor_m_h, center=true);
        translate([0, -8, -motor_m_h/2]){
          roundedRect([10, motor_d, ,motor_m_h], 3);
        }
      }
      translate([gear_X, 0, gear_m_h/2]){
        cylinder(d1=20, d2=10, h=gear_m_h, center=true);
      }
      // Halfes mount
      translate([cut_X, 0, cut_m_h/2]){
        cube(size=[cut_m_l, mm_w, cut_m_h], center=true);
      }
      // Sensor 1 mount
      translate([s1_X+s_wall/2, 0, s1_h/2]){
        cube(size=[s_wall, s1_w, s1_h], center=true);
      }
      // Sensor 2 mount
      translate([s2_X-s_wall/2, 0, s2_h/2]){
        cube(size=[s_wall, s1_w, s2_h], center=true);
      }
      
    }
    // Sensor 1 mount
    for(i=[0:1:1])mirror([0,i,0])
    translate([s1_X+s_wall/2, 3, s1_h-4]){
      rotate([0,90,0])
      cylinder(d=M3_hole, h=s_wall*1.1, center=true);
    }
    for(i=[0:1:1])mirror([0,i,0])
    translate([s2_X-s_wall/2, 3, s2_h-4]){
      rotate([0,90,0])
      cylinder(d=M3_hole, h=s_wall*1.1, center=true);
    }
    // Halfes cut
    translate([cut_X, 0, 0]){
      cube(size=[cut_w, mm_w*1.1, 50], center=true);
    }
    for(i=[0:1:1])mirror([0,i,0])
    translate([cut_X, 15, cut_m_h/2]){
      rotate([0, 90, 0])
      cylinder(d=M3_hole, h=cut_m_l*1.1, center=true);
    }
    // motor cut
    translate([motor_X, 0, motor_m_h/2+mm_wall]){
      cylinder(d=motor_d, h=motor_m_h, center=true);
    }
    // Motor screw cut
    translate([motor_X, 0, motor_m_h/2+mm_wall]){
      rotate([90, 0, 0])
      cylinder(d=M3_hole, h=motor_d*2, center=true);
    }
    // Nut cut
    translate([motor_X, -motor_d/2-4, motor_m_h/2+mm_wall]){
      cube(size=[6, 3, motor_m_h], center=true);
    }
    // cable cut
    translate([motor_X, motor_d/2, motor_m_h/2+mm_wall]){
      cube(size=[3, 10, motor_m_h], center=true);
    }
    
    // Gear shaft cut
    translate([gear_X, 0, gear_m_h/2]){
      cylinder(d=M3_hole, h=gear_m_h*1.1, center=true);
    }      
    translate([gear_X, 0, gear_m_h/2-15]){
      hull(){
        cylinder(d=8, h=gear_m_h, center=true);
        cylinder(d=M3_hole, h=gear_m_h+4, center=true);
      }
    }
    // Base plate mount holes
    for(i=[0:1:1])mirror([0,i,0]){
      for(j=[0:1:1])mirror([j,0,0])
      translate([mm_l/2-screw_e, mm_w/2-screw_e, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
    }
  }

}

module sensor_disc_gear(){
  sdg_wall = 1.35;
  sdg_d = 96;
  sdg_gaps = 10;
  shaft_h = 5;
  shaft_d = 10;
  
  angle = 360.0 / sdg_gaps;
  
  difference(){
    union(){
      gear(teeth=150,h=sdg_wall, shaft=M3_hole, mod=2, s=1.0);
      translate([0, 0, shaft_h/2]){
        cylinder(d1=shaft_d*1.5, d2=shaft_d, h=shaft_h, center=true);
      }
    }
    // shaft
    translate([0, 0, shaft_h/2]){
      cylinder(d=M3_hole, h=shaft_h*1.1, center=true);
    }    
    translate([0, 0, shaft_h/2+sdg_wall]){
      cylinder(d=M3_nut_e, h=shaft_h, center=true, $fn=6);
    }    
    // Mark slit
    translate([sdg_d/4, 0, sdg_wall/2]){
      cube(size=[30, 3, sdg_wall*1.1], center=true);
    }    
    // Teeth
    difference(){
      intersection(){
        cylinder(d=sdg_d-4, h=sdg_wall*2.1, center=true);
        for(i=[0:angle:360]){
          rotate([0, 0, i])
          hull(){
            cylinder(d=0.1, h=sdg_wall*2.1, center=true);
            rotate([0, 0, angle/4])
            translate([sdg_d, 0, 0])
            cylinder(d=0.1, h=sdg_wall*2.1, center=true);
            rotate([0, 0, -angle/4])
            translate([sdg_d, 0, 0])
            cylinder(d=0.1, h=sdg_wall*2.1, center=true);
          }
        }
      }
      cylinder(d=sdg_d-11, h=sdg_wall*2.1, center=true);        
    }
    
  }

}

module sensor_disc_motor(){
  sdm_d = 70;
  sdm_wall = 1.35;
  sdm_gaps = 10;
  shaft_d = 1.75;
  
  angle = 360.0 / sdm_gaps;
  
  translate([0, 0, sdm_wall/2]){
    difference(){
      union(){
        cylinder(d=sdm_d, h=sdm_wall, center=true);
        gear(teeth=8,h=10, shaft=shaft_d, mod=2, s=1.0);
      }
      // Shaft
      cylinder(d=shaft_d, h=sdm_wall*1.1, center=true);
      // 3rd sensor hole
      translate([sdm_d/2-18, 0, 0])
      cube(size=[20, 3, sdm_wall*1.1], center=true);
      
      // Teeth
      difference(){
        intersection(){
          cylinder(d=sdm_d-4, h=sdm_wall*1.1, center=true);
          for(i=[0:angle:360]){
            rotate([0, 0, i])
            hull(){
              cylinder(d=0.1, h=sdm_wall*1.1, center=true);
              rotate([0, 0, angle/4])
              translate([sdm_d, 0, 0])
              cylinder(d=0.1, h=sdm_wall*1.1, center=true);
              rotate([0, 0, -angle/4])
              translate([sdm_d, 0, 0])
              cylinder(d=0.1, h=sdm_wall*1.1, center=true);
            }
          }
        }
        cylinder(d=sdm_d-11, h=sdm_wall*1.1, center=true);        
      }
    }
  }
  
}

module LED_board_mount(){
  LEDbm_l = 50;
  LEDbm_w = 50;
  LEDbm_wall = 2;
  LEDbm_h = 15;
  LED_dis = 15;
  LED_d = 5;
  
  m_dis = LEDbm_l + 8;
  m_do = 14;
  m_di_1 = 8;
      
  difference(){
    union(){
      roundedRect([LEDbm_l, LEDbm_w, LEDbm_h], 3);
      hull(){
        translate([m_dis/2, 0, LEDbm_h-LEDbm_wall/2])
        cylinder(d=m_do, h=LEDbm_wall, center=true);
        translate([-m_dis/2, 0, LEDbm_h-LEDbm_wall/2])
        cylinder(d=m_do, h=LEDbm_wall, center=true);
        translate([0, 0, LEDbm_h-10])
        cube(size=[LEDbm_l, m_do, 0.1], center=true);
      }
    }
    // Center cut
    translate([0, 0, LEDbm_wall]){
      a = LEDbm_l - 2*LEDbm_wall;
      b = LEDbm_w - 2*LEDbm_wall;
      roundedRect([a, b, LEDbm_h], 3);
    }
    // mount holes
    for(i=[0:1:1])mirror([i,0,0]){
      translate([m_dis/2, 0, LEDbm_h-LEDbm_wall/2+0.2])
      cylinder(d=M3_hole, h=LEDbm_wall, center=true);
      translate([m_dis/2, 0, LEDbm_h/2-LEDbm_wall])
      cylinder(d=m_di_1, h=LEDbm_h, center=true);
    }
    // cable cut
    translate([0, 10, LEDbm_h/2])
    rotate([90, 0, 0]){
      cylinder(d=5, h=LEDbm_w, center=true);
    }
    
    // LED holes (dice pattern)
    translate([0, 0, LEDbm_wall/2]){
      cylinder(d=LED_d, h=LEDbm_wall*1.1, center=true);
      for(i=[0:1:1])mirror([0,i,0])for(j=[0:1:1])mirror([j,0,0]){
        translate([0, LED_dis, 0]){
          cylinder(d=LED_d, h=LEDbm_wall*1.1, center=true);
        }
        translate([LED_dis, LED_dis, 0]){
          cylinder(d=LED_d, h=LEDbm_wall*1.1, center=true);
        }
      }
    }
    
  }
  
}







module chassis(){
  ch_w = 250;
  ch_l = 350;
  ch_h = 100;


  translate([0, (ch_w-bar_e)/2+50, (ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([(ch_l-bar_e)/2+50, 0, (ch_h-bar_e)/2]){
    bar(ch_w, [90,0,0]);
  }
  
  // Length
  translate([0, (ch_w-bar_e)/2, (ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([0, -(ch_w-bar_e)/2, (ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([0, (ch_w-bar_e)/2, -(ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([0, -(ch_w-bar_e)/2, -(ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  // Height
  translate([ch_l/2-bar_e*1.5, ch_w/2-bar_e*1.5, 0]){
    bar(ch_h, [0,0,0]);
  }
  translate([-(ch_l/2-bar_e*1.5), ch_w/2-bar_e*1.5, 0]){
    bar(ch_h, [0,0,0]);
  }
  translate([-(ch_l/2-bar_e*1.5), -(ch_w/2-bar_e*1.5), 0]){
    bar(ch_h, [0,0,0]);
  }
  translate([ch_l/2-bar_e*1.5, -(ch_w/2-bar_e*1.5), 0]){
    bar(ch_h, [0,0,0]);
  }

  // Width
  translate([(ch_l-bar_e)/2, 0, (ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  translate([-(ch_l-bar_e)/2, 0, (ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  translate([-(ch_l-bar_e)/2, 0, -(ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  translate([(ch_l-bar_e)/2, 0, -(ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  
}

module pi_mount(){
  //Raspberry Pi mount points
  raspi_m_l = 58;
  raspi_m_w = 49;
  raspi_m_shift_x = -10;
  raspi_m_shift_y = 0;
  raspi_m_d = 5;
  raspi_m_screw_d = 2;
  raspi_m_h = 7;
  raspi_m_socket = 1;  
  
  pm_wall = 2;
  pm_w = 74;
  pm_l = 100;
  
  wall_h = 8;
  mount_holes_x = 29;
  
  tower_m_d = 20;
  tower_m_x = -5;
  
  //Central cut
  cc_d = 20;
  cc_l = 25;
  
  //micro USB power supply cut
  psc_d = 50;
  psc_x = -32;
  psc_z = 27;

  pi_mm_h = 6;
  // Pi mount mount (base plate)
  translate([0, 70, pi_mm_h/2]){
    difference(){
      hull(){
        translate([3.5*ch_dis_y-6.5, 2*ch_dis_x, 0]){
          cylinder(d=10, h=pi_mm_h, center=true);
        }
        translate([3.5*ch_dis_y-6.5, -2*ch_dis_x, 0]){
          cylinder(d=10, h=pi_mm_h, center=true);
        }
        translate([3.5-4.5*ch_dis_y, 0, 0]){
          cylinder(d=10, h=pi_mm_h, center=true);
        }        
      }
      //Mount holes Pi mount
      translate([3.5*ch_dis_y-6.5, 2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pi_mm_h*2, center=true);
      }
      translate([3.5*ch_dis_y-6.5, -2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pi_mm_h*2, center=true);
      }
      translate([3.5-4.5*ch_dis_y, 0, 0]){
        cylinder(d=M3_hole, h=pi_mm_h*2, center=true);
      }        
      translate([3.5*ch_dis_y-6.5, 2*ch_dis_x, pm_wall]){
        cylinder(d=M3_nut_e, h=pi_mm_h, center=true, $fn=6);
      }
      translate([3.5*ch_dis_y-6.5, -2*ch_dis_x, pm_wall]){
        cylinder(d=M3_nut_e, h=pi_mm_h, center=true, $fn=6);
      }
      translate([3.5-4.5*ch_dis_y, 0, pm_wall]){
        cylinder(d=M3_nut_e, h=pi_mm_h, center=true, $fn=6);
      }
      // Mount holes bottom plate
      for(i=[0:1:1])mirror([i,0,0])
      translate([15, 0, 0]){
        cylinder(d=M3_hole, h=pi_mm_h*1.1, center=true);
        hull(){
          translate([0, 0, -pm_wall])
          cylinder(d=M3_hole, h=pi_mm_h*1, center=true);
          translate([0, 0, -(pm_wall+2)])
          cylinder(d=8, h=pi_mm_h*1, center=true);
        }
      }
    }
  }  
  
  translate([0, 0, pm_wall/2]){
    block_l = 4;
    block_w = 35;
    block_h = servo_w+5;
    block_edge = 8;

    
    difference(){
      union(){
        cube(size=[pm_l, pm_w, pm_wall], center=true);
        //Pi mount points
        translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall/2]){
          translate([raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=15, d2=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=15, d2=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=15, d2=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=15, d2=raspi_m_d, h=raspi_m_h, center=true);
          }
        }
        //Walls
        translate([(pm_l-pm_wall)/2, 0, raspi_m_h/2]){
          cube(size=[pm_wall, pm_w, raspi_m_h], center=true);
        }
        translate([(pm_l-pm_wall)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 35]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([(pm_wall-pm_l)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 33]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([0, (pm_w-pm_wall)/2, wall_h/2]){
          cube(size=[pm_l, pm_wall, wall_h], center=true);
        }
        translate([0, -(pm_w-pm_wall)/2, wall_h/2]){
          cube(size=[pm_l, pm_wall, wall_h], center=true);
        }
      }
      //Mount holes on chassis
      translate([3.5*ch_dis_y-6.5, 2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5*ch_dis_y-6.5, -2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5-4.5*ch_dis_y, 0, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      //Mount holes camera and lamp metal strip
      for(i=[0:1:1])mirror([0,i,0])
      translate([7, 25, 0]){
        hull(){
          translate([0, 3, 0])
          cylinder(d=M3_hole, h=pm_wall*2, center=true);
          translate([0, -3, 0])
          cylinder(d=M3_hole, h=pm_wall*2, center=true);
        }
      }
      for(i=[0:1:1])mirror([0,i,0])
      translate([-20, 25, 0]){
        hull(){
          translate([0, 3, 0])
          cylinder(d=M3_hole, h=pm_wall*2, center=true);
          translate([0, -3, 0])
          cylinder(d=M3_hole, h=pm_wall*2, center=true);
        }
      }

      //Central hole
      hull(){
        translate([cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
        translate([-cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
      }
      //Mount holes power pole
      holes = 9;
      for(i=[1:1:holes]){
        translate([-pm_l/2+i*ch_dis_x, pm_w/2, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
          }
        }
        translate([-pm_l/2+i*ch_dis_x, pm_w/2-pm_wall*1.5, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        if(i>3){
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
            }
          }
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2+pm_wall*1.5, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
            }
          }
        }

      }
      // Cut micro USB for power supply
      translate([psc_x, -pm_w/2, psc_z]){
        rotate([90, 0, 0]){
          cylinder(d=psc_d, h=pm_wall*2.1, center=true);
        }
      }
      
      //Pi mount holes
      translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall]){
        translate([raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
      }
      
    }
    
  }
}

module arduino_mount(){
  //Arduino Uno mount points
  hole_shift_x = -21;
  hole_shift_y = -24;

  uno_hole1_x = 0 + hole_shift_x;
  uno_hole1_y = 0 + hole_shift_y;
  uno_hole2_x = 1.3 + hole_shift_x;
  uno_hole2_y = 15.2 + 27.9 + 5.1 + hole_shift_y;
  uno_hole3_x = 50.8 + 1.3 + hole_shift_x;
  uno_hole3_y = 27.9 + 5.1 + hole_shift_y;
  uno_hole4_x = uno_hole3_x;
  uno_hole4_y = 5.1 + hole_shift_y;
  
  hole_d = 1;
  mount_d = 4;
  mount_h = 4;
  
  
  um_wall = 2;
  um_w = 55;
  um_l = 70;  

  // Mount holes on chassis
  mh_d = 10;
  mh1_x = -(um_l + mh_d)/2;
  mh1_y = 0;
  mh2_x = (um_l + mh_d)/2;
  mh2_y = um_w/4;
  mh3_x = (um_l + mh_d)/2;
  mh3_y = -um_w/4;
  
  mh_h = 20;
  brim_h = 0.35;
  brim_d = 17;
  
  /*
  for(i=[0:1:2]){
    translate([i*12-12, 35, mh_h/2]){
      difference(){
        union(){
          cylinder(d=mh_d, h=mh_h, center=true);
          translate([0, 0, (brim_h-mh_h)/2]){
            cylinder(d=brim_d, h=brim_h, center=true);
          }
        }
        cylinder(d=M3_hole, h=mh_h*1.1, center=true);
      }
    }
  }
  */
  difference(){
    union(){
      roundedRect([um_l, um_w, um_wall], 5);
      // Mounts on chassis
      translate([mh1_x, mh1_y, um_wall/2]){
        cylinder(d=mh_d, h=um_wall, center=true);
        translate([mh_d/4, 0, 0]){
          cube(size=[mh_d/2, mh_d, um_wall], center=true);
        }
      }
      translate([mh2_x, mh2_y, um_wall/2]){
        cylinder(d=mh_d, h=um_wall, center=true);
        translate([-mh_d/4, 0, 0]){
          cube(size=[mh_d/2, mh_d, um_wall], center=true);
        }
      }
      translate([mh3_x, mh3_y, um_wall/2]){
        cylinder(d=mh_d, h=um_wall, center=true);
        translate([-mh_d/4, 0, 0]){
          cube(size=[mh_d/2, mh_d, um_wall], center=true);
        }
      }
      
      // Mounts Arduino Uno
      translate([0, 0, mount_h/2+um_wall]){
        translate([uno_hole1_x, uno_hole1_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
        translate([uno_hole2_x, uno_hole2_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
        translate([uno_hole3_x, uno_hole3_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
        translate([uno_hole4_x, uno_hole4_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
      }
    }
    // Mount holes on chassis
    translate([mh1_x, mh1_y, um_wall/2]){
      cylinder(d=M3_hole, h=um_wall*1.1, center=true);
    }
    translate([mh2_x, mh2_y, um_wall/2]){
      cylinder(d=M3_hole, h=um_wall*1.1, center=true);
    }
    translate([mh3_x, mh3_y, um_wall/2]){
      cylinder(d=M3_hole, h=um_wall*1.1, center=true);
    }

    
    // Mount holes Arduino Uno
    translate([0, 0, (mount_h+um_wall)/2]){
      translate([uno_hole1_x, uno_hole1_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
      translate([uno_hole2_x, uno_hole2_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
      translate([uno_hole3_x, uno_hole3_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
      translate([uno_hole4_x, uno_hole4_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
    }
  }
    
}


module servo_mount(){
  
  s_w = 30;
  s_w2 = 50;
  s_l = 30;
  s_h = 80;
  s_wall = 2;

  //Clamp
  c_l = 57;
  c_w = 10;
  c_h = 15;
  c_mount_holes = 25;
  c_shift = 10;
  
  enf_l = 25;
  enf_h = 75;

  translate([s_h/2*(1-Assembled), 0, s_l/2*(1-Assembled)]){
    rotate([270*(1-Assembled), 0, 90*(1-Assembled)]){
      difference(){
        union(){
          roundedRect([s_w2, s_l, s_wall], 5, [1,1,1,1]);
          translate([0, s_l/2, s_h/2]){
            rotate([90, 0, 0]){
              roundedRect([s_w, s_h, s_wall], 5, [0,0,1,1]);
            }
          }
          hull(){
            translate([(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
          hull(){
            translate([-(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([-(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
        }
        // Clamp mount holes
        translate([0, 0, s_h/2-c_mount_holes+c_shift]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=200.1, center=true);
          }
        }    
        translate([0, 0, s_h/2+c_mount_holes+c_shift]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=200.1, center=true);
          }
        }    
        // Bottom mount holes
        for(i=[0:1:1])mirror([i, 0, 0]){
          translate([20, 10, 0]){
            cylinder(d=M3_hole, h=20.1, center=true);
          }    
          translate([20, 0, 0]){
            cylinder(d=M3_hole, h=20.1, center=true);
          }    
          translate([20, -10, 0]){
            cylinder(d=M3_hole, h=20.1, center=true);
          }    
        }
      }
    }
    
  }

  // Clamp
  translate([0, 25-Assembled*8, 23*Assembled+c_h/2]){
    rotate([90*Assembled, 90*Assembled, 0]){
      difference(){
        cube(size=[c_l, c_w, c_h], center=true);
        translate([0, 0, 4]){
          cube(size=[42, c_w*1.1, c_h], center=true);
        }
        translate([c_mount_holes, 0, 0]){
          cylinder(d=M3_hole, h=c_h*1.1, center=true);
        }    
        translate([-c_mount_holes, 0, 0]){
          cylinder(d=M3_hole, h=c_h*1.1, center=true);
        }    
      }
    }
  }
  
}


module camera_mount(){
  cam_w = 27;
  cam_h = 25;
  cam_l = 14;
  cam_pos = -1;
  cam_slot = 1.5;
  cam_slot_w = 3;

  cm_wall = 2;
  cm_w = cam_w + 35;
  cm_h = cam_h+cm_wall;
  lever_radius = 5;

  lever_l = 45;
  lever_gap = 20;
  lever_z = lever_radius-cm_h/2;
  
  //Servo horn mount holes
  shm_l1 = lever_l - 13.7-21;

  lever2_l = -15;
  lever2_radius = 5;
  lever2_z = lever2_radius-cm_h/2;

  LED_d = 5.1;
  LED_w = cm_w - 16;
  LED_no = 3;

  translate([0, 0, 0]){
  
    //Camera box
    difference(){
      translate([0, 0, cm_h/2]){
        rotate([90, 0, 180]){
          difference(){
            roundedRect(size=[cm_w, cm_h, cm_wall], radius=3);
            gap = cm_h / LED_no;
            for(i=[0:1:LED_no-1]){
              translate([LED_w/2, (cm_h-gap)/2-i*gap, cm_wall/2]){
                cylinder(d=LED_d, h=cm_wall*1.1, center=true);
              }
              mirror([1, 0, 0]){
                translate([LED_w/2, (cm_h-gap)/2-i*gap, cm_wall/2]){
                  cylinder(d=LED_d, h=cm_wall*1.1, center=true);
                }
              }
            }
          }
          translate([0, 0, 0]){
            roundedRect(size=[cam_w+2*cm_wall, cm_h, cam_l], radius=2);
          }
        }
      }
      // Cut camera
      translate([0, cam_l/2+cm_wall-2, cm_h/2+cm_wall]){
        cube(size=[cam_w-2*cam_slot_w, cam_l-4, cam_h], center=true);
      }
      translate([0, cam_l/2+cm_wall, cm_h/2+cm_wall+12.5]){
        cube(size=[15, cam_l, cam_h], center=true);
      }
      translate([0, cam_l/2+cm_wall, cm_h/2+cm_wall]){
        rotate([90, 0, 0]){
          cylinder(d=15, h=cam_l, center=true);
        }
      }
      // Cut camera slit
      translate([0, cam_l/2+cam_pos, cm_h/2+cm_wall]){
        cube(size=[cam_w, cam_slot, cam_h], center=true);
      }
    }
    
    
    //Lever mounts
    translate([0, 0, cm_h/2]){
      rotate([0, 90, 0]){
        difference(){
          hull(){
            translate([-lever_z, -lever_l, 0]){
              cylinder(r=lever_radius, h=cm_wall, center=true);  
            }
            translate([0, cm_wall/2, 0]){
              cube(size=[cm_h, cm_wall, cm_wall], center=true);
            }
          }
          hull(){
            translate([-lever_z, -lever_l, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
            translate([-lever_z, -lever_l+(lever_l-shm_l1)/2-3, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
          }
          hull(){
            translate([-lever_z, -shm_l1, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
            translate([-lever_z, -lever_l+(lever_l-shm_l1)/2+3, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
          }
        }
      }
    }
    
  }


}



module servo_horn(){
  horn_d = 41;
  horn_w1 = 12;
  horn_w2 = 6;
  horn_thickness = 3;
  horn_mount = 13.7;
  

  //cylinder($fn=tow, r=radius, h=wheel_w, center=true);
  x1=0;
  y1=horn_w1/2;
  x2=horn_d/2-horn_w2/2;
  y2=horn_w2/2;
  x3=horn_d/2-horn_w2/2;
  y3=-horn_w2/2;
  x4=0;
  y4=-horn_w1/2;
  
  for(i=[0:90:360]){
    rotate([0, 0, i]){
      translate([horn_mount, 0, -5]){
        cylinder(d=3, h=10.1, center=true);
      }
      translate([(horn_d-horn_w2)/2, 0, 0]){
        cylinder(d=horn_w2, h=horn_thickness, center=true);
      }
      translate([0, 0, -horn_thickness/2]){
        linear_extrude(height=horn_thickness){
          polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
        }
      }
    }
  }

}

module servo(tolerance=0, mount_holes=1, horn=true, cable=true){
  mh_dis1 = 49;
  mh_dis2 = 10;
  
  translate([0, 0, servo_h/2]){
    cube(size=[servo_l+tolerance, servo_w+tolerance, servo_h+tolerance], center=true);
      if(horn==true){
        translate([servo_l/2-servo_axis_offset, 0, 25]){
          rotate([0, 0, 90]){
            cylinder(d=30, h=2, center=true);
          }
        }
      }
  }
  translate([0, 0, servo_h1+1]){
    cube(size=[servo_lt, servo_w+tolerance, 3], center=true);
  }
  if(mount_holes == 1){
    if(cable==true){
      translate([-servo_l/2, 0, servo_h/2]){
        cylinder(d=7, h=servo_h, center=true);
      }
    }
    translate([mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([-mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([-mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
  }

  
}

module gear(teeth=10,h=5, shaft=M3_hole, mod=3.5, s=1.0){
  alpha = 180/teeth;
  r=(mod/2.0)/tan(alpha);
  
  x = cos(alpha) * r;
  t_r = mod/sqrt(3);
  t_h = mod*sqrt(3)/2.0;
  
  difference(){
    linear_extrude(height = h, scale=s){
      union(){
        for(i=[0:1:teeth-1]){
          rotate([0, 0, i*360/teeth]){  
            translate([x+(t_h-t_r),0,0]){
              circle(r=t_r, $fn=3);
            }
          }
        }
        rotate([0, 0, alpha])
        circle(r=r, $fn=teeth);
      }
    }
    translate([0, 0, h/2]){
      cylinder(d=shaft, h=h*1.1, center=true);
    }
    if(shaft==-1){
      translate([0, 0, h/2]){
        difference(){
          cylinder(d=motor_shaft, h=h*1.1, center=true);
          translate([0, motor_shaft_shift, 0]){
            cube(size=[motor_shaft, motor_shaft, 16], center=true);
          }
        }
      }
    }
  }
  
}



module roundedRect(size, radius, edges=[1, 1, 1, 1]){
  x = size[0];
  y = size[1];
  z = size[2];

  linear_extrude(height=z){
    hull(){
        // place 4 circles in the corners, with the given radius
        if(edges[0]){
          translate([(-x/2)+(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
        if(edges[1]){
          translate([(x/2)-(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[2]){
          translate([(-x/2)+(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[3]){
          translate([(x/2)-(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
    }
  }
}
